"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DEFAULT_CHUNK_SIZE = 65536;
class BufferPool {
    constructor(preAlloc = 1, chunkSize = exports.DEFAULT_CHUNK_SIZE) {
        this.chunkSize = chunkSize;
        this.pool = [];
        while (preAlloc--) {
            this.free(Buffer.allocUnsafe(this.chunkSize));
        }
    }
    alloc() {
        return this.pool.pop() || Buffer.allocUnsafe(this.chunkSize);
    }
    free(buffer) {
        this.pool.push(buffer);
    }
}
exports.BufferPool = BufferPool;
