"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const cluster = require("cluster");
const os_1 = require("os");
let errlock = 0;
if (cluster.isMaster) {
    const workerNum = Math.max(os_1.cpus().length, 4);
    console.info(`Spawning ${workerNum} workers`);
    for (let i = 0; i < workerNum; i++) {
        cluster.fork();
    }
    cluster.on("exit", (worker, code, signal) => {
        errlock++;
        if (errlock >= 1) {
            console.error("Error lock reached - Something has gone dreadfully wrong");
        }
        else {
            console.warn("worker has been lost to the abyss", worker.process.pid);
            cluster.fork();
        }
    });
}
else {
    require("./test");
}
