export interface Request {
    method: HttpMethod;
    url: string;
    body: any;
    headers: {
        [name: string]: string;
    };
    rawBody: any;
    params: {
        [name: string]: string;
    };
    query: {
        [name: string]: string;
    };
}
export interface Response {
    statusCode: number;
    body: any;
    headers: {
        [name: string]: string;
    };
}
export declare type Handler = (req: Request, done: (error: Error, res: Response) => void) => void;
export declare enum HttpMethod {
    GET = "GET",
    POST = "POST",
    PUT = "PUT",
    OPTIONS = "OPTIONS",
    DELETE = "DELETE",
    PATCH = "PATCH"
}
export declare class SlimJim {
    private router;
    private server;
    constructor();
    start(port: number, address: string, callback?: () => void): void;
    get(path: string, handler: Handler): void;
    post(path: string, handler: Handler): void;
    put(path: string, handler: Handler): void;
    patch(path: string, handler: Handler): void;
    options(path: string, handler: Handler): void;
    delete(path: string, handler: Handler): void;
    endpoint(method: HttpMethod, path: string, handler: Handler): void;
    stop(callback: () => void): void;
}
